//
//  helpViewController.m
//  scummvm
//
//  Created by DotEmu on 18/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#import "switchViewController.h"
#import "helpViewController.h"
#import "Gob1MenuViewController.h"

extern int idSoundSFX;
extern int _GobLanguage;

@implementation helpViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
    [super viewDidLoad];
	
	//NSLog(@"helpViewController viewDidLoad");		
	bWarning = false;
	m_prevState.hidden = YES;
	m_nextState.hidden = NO;
	etatNext = 0;
	
	m_menu.exclusiveTouch = YES;
	m_prevState.exclusiveTouch = YES;
	m_nextState.exclusiveTouch = YES;
	
	//clear
	[self removeBackground];
	
	//load
	[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
	[self loadPageZero];
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}


- (void)didReceiveMemoryWarning 
{
	//NSLog(@"helpViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
	bWarning = true;
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
	switch( etatNext )
	{
		case 0:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			[self removePageFour];
			[self removePageFive];
			[self removePageSix];
			break;
		case 1:
			[self removePageTwo];
			[self removePageThree];
			[self removePageFour];
			[self removePageFive];
			[self removePageSix];
			break;
		case 2:
			[self removePageOne];
			[self removePageThree];
			[self removePageFour];
			[self removePageFive];
			[self removePageSix];
			break;
		case 3:
			[self removePageOne];
			[self removePageTwo];
			[self removePageFour];
			[self removePageFive];
			[self removePageSix];
			break;
		case 4:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			[self removePageFive];
			[self removePageSix];
			break;
		case 5:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			[self removePageFour];
			[self removePageSix];
			break;
		case 6:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			[self removePageFour];
			[self removePageFive];
			break;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"helpViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}
}


- (void)dealloc 
{
	//NSLog(@"helpViewController dealloc");	
	
    [super dealloc];
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}
}

-(void) loadPageZero
{
	generalWebV.backgroundColor = [UIColor clearColor];
	generalWebV.opaque = NO;
	generalWebV.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath = [[NSBundle mainBundle] resourcePath];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error = nil;
	NSString *fullPath = [[NSBundle mainBundle] pathForResource:NSLocalizedString(@"HelpURL", @"help-general") ofType:@"html"];
	NSString *helpHtml = [NSString stringWithContentsOfFile:fullPath encoding:NSUTF8StringEncoding error:&error];
	
	[generalWebV loadHTMLString:helpHtml baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath]]];
	
	generalWebV.hidden = NO;
	activityIndicatorGWV.hidden = NO;
	
	generalWebV.delegate = self;
	[self.view insertSubview:generalWebV aboveSubview:fondV];
	[self.view insertSubview:activityIndicatorGWV aboveSubview:fondV];
}

-(void) removePageZero
{	
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}
}

-(void) loadPageOne
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	gob1V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 85, 35, 54)];		
	UIImage* gob = [[UIImage imageNamed:@"gobliiins1.png"] retain];		
	[gob1V setImage:gob];		
	[gob release];		
	[self.view addSubview:gob1V];
	
	gob1TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 75, 330, 100 )];
	gob1TV.backgroundColor = [UIColor clearColor];
	gob1TV.font = [UIFont fontWithName:@"Arial" size:12];
	gob1TV.scrollEnabled = NO;
	gob1TV.editable = NO;
	gob1TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	gob1TV.text = NSLocalizedString(@"Help1.1Text", @"This gobliiin is named Dwayne, the technician. He collects the objects he finds along the way and applies them sensibly. Unfortunately, he is weak and can therefore carry one object at a time.");
	[gob1TV setUserInteractionEnabled:NO];
	[self.view addSubview:gob1TV];	
	
	gob2V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 155, 35, 54)];		
	gob = [[UIImage imageNamed:@"gobliiins2.png"] retain];		
	[gob2V setImage:gob];		
	[gob release];		
	[self.view addSubview:gob2V];
	
	gob2TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 145, 330, 100 )];
	gob2TV.backgroundColor = [UIColor clearColor];
	gob2TV.font = [UIFont fontWithName:@"Arial" size:12];
	gob2TV.scrollEnabled = NO;
	gob2TV.editable = NO;
	gob2TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	gob2TV.text = NSLocalizedString(@"Help1.2Text", @"The warrior, Bobo, knows nothing but sheer muscle power. He uses it when he sees fit. He is of strong physique and uses ropes for climbing and for getting around.");
	[gob2TV setUserInteractionEnabled:NO];	
	[self.view addSubview:gob2TV];	
	
	gob3V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 225, 35, 54)];		
	gob = [[UIImage imageNamed:@"gobliiins3.png"] retain];		
	[gob3V setImage:gob];		
	[gob release];		
	[self.view addSubview:gob3V];
	
	gob3TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 215, 330, 60 )];
	gob3TV.backgroundColor = [UIColor clearColor];
	gob3TV.font = [UIFont fontWithName:@"Arial" size:12];
	gob3TV.scrollEnabled = NO;
	gob3TV.editable = NO;
	gob3TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	gob3TV.text = NSLocalizedString(@"Help1.3Text", @"Hooter is the magician who casts spells from a distance. However, he cannot always control their effects.");
	[gob3TV setUserInteractionEnabled:NO];	
	[self.view addSubview:gob3TV];	
}

-(void) removePageOne
{
	if( gob1V != nil && gob1V.superview != nil )
	{
		[gob1V removeFromSuperview];
		[gob1V release];
		gob1V = nil;
	}
	if( gob1TV != nil && gob1TV.superview != nil )
	{
		[gob1TV removeFromSuperview];
		[gob1TV release];	
		gob1TV = nil;
	}
	if( gob2V != nil && gob2V.superview != nil )
	{
		[gob2V removeFromSuperview];
		[gob2V release];		
		gob2V = nil;
	}
	if( gob2TV != nil && gob2TV.superview != nil )
	{
		[gob2TV removeFromSuperview];
		[gob2TV release];		
		gob2TV = nil;
	}
	if( gob3V != nil && gob3V.superview != nil )
	{
		[gob3V removeFromSuperview];
		[gob3V release];	
		gob3V = nil;
	}
	if( gob3TV != nil && gob3TV.superview != nil )
	{
		[gob3TV removeFromSuperview];
		[gob3TV release];		
		gob3TV = nil;
	}
}

-(void) loadPageTwo
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	head1V = [[UIImageView alloc] initWithFrame:CGRectMake(70, 85, 50, 50)];		
	UIImage* gob = [[UIImage imageNamed:@"Tete1.png"] retain];		
	[head1V setImage:gob];		
	[gob release];		
	[self.view addSubview:head1V];
	
	headTV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 80, 330, 100 )];
	headTV.backgroundColor = [UIColor clearColor];
	headTV.font = [UIFont fontWithName:@"Arial" size:12];
	headTV.scrollEnabled = NO;
	headTV.editable = NO;
	headTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	headTV.text = NSLocalizedString(@"Help2.1Text", @"In the middle of the inventory area, you will find a crystal ball with the gobliiin you control. Just touch it to switch to another one.");
	[headTV setUserInteractionEnabled:NO];	
	[self.view addSubview:headTV];	
	
	itrV = [[UIImageView alloc] initWithFrame:CGRectMake(80, 155, 30, 47)];		
	gob = [[UIImage imageNamed:@"pt interr.png"] retain];		
	[itrV setImage:gob];		
	[gob release];		
	[self.view addSubview:itrV];
	
	itrTV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 150, 330, 100 )];
	itrTV.backgroundColor = [UIColor clearColor];
	itrTV.font = [UIFont fontWithName:@"Arial" size:12];
	itrTV.scrollEnabled = NO;
	itrTV.editable = NO;
	itrTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	itrTV.text = NSLocalizedString(@"Help2.2Text", @"This interrogation mark will show you the hints of the current level to help you resolve it!");
	[itrTV setUserInteractionEnabled:NO];		
	[self.view addSubview:itrTV];	
	
	menV = [[UIImageView alloc] initWithFrame:CGRectMake(65, 225, 59, 26)];		
	gob = [[UIImage imageNamed:@"menu.png"] retain];		
	[menV setImage:gob];		
	[gob release];		
	[self.view addSubview:menV];
	
	menTV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 210, 330, 60 )];
	menTV.backgroundColor = [UIColor clearColor];
	menTV.font = [UIFont fontWithName:@"Arial" size:12];
	menTV.scrollEnabled = NO;
	menTV.editable = NO;
	menTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	menTV.text = NSLocalizedString(@"Help2.3Text", @"This button will show the ingame menu where you will be able to restart the level, to change the settings or to quit the game.");
	[menTV setUserInteractionEnabled:NO];			
	[self.view addSubview:menTV];	
}

-(void) removePageTwo
{
	if( head1V != nil && head1V.superview != nil )
	{
		[head1V removeFromSuperview];
		[head1V release];
		head1V = nil;
	}
	if( itrV != nil && itrV.superview != nil )
	{
		[itrV removeFromSuperview];
		[itrV release];		
		itrV = nil;
	}
	if( menV != nil && menV.superview != nil )
	{
		[menV removeFromSuperview];
		[menV release];		
		menV = nil;
	}
	
	if( headTV != nil && headTV.superview != nil )
	{
		[headTV removeFromSuperview];
		[headTV release];		
		headTV = nil;
	}
	if( itrTV != nil && itrTV.superview != nil )
	{
		[itrTV removeFromSuperview];
		[itrTV release];			
		itrTV = nil;
	}
	if( menTV != nil && menTV.superview != nil )
	{
		[menTV removeFromSuperview];
		[menTV release];		
		menTV = nil;
	}
}

-(void) loadPageSix
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	icon1V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 85, 36, 36)];		
	UIImage* gob = [[UIImage imageNamed:@"Marron-Pied3.png"] retain];		
	[icon1V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon1V];
	
	ic1TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 75, 330, 100 )];
	ic1TV.backgroundColor = [UIColor clearColor];
	ic1TV.font = [UIFont fontWithName:@"Arial" size:12];
	ic1TV.scrollEnabled = NO;
	ic1TV.editable = NO;
	ic1TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	ic1TV.text = NSLocalizedString(@"Help6.1Text", @"This step-icon is the action which allows you to move your gobliiin at the location selected.");
	[ic1TV setUserInteractionEnabled:NO];				
	[self.view addSubview:ic1TV];	
	
	icon2V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 135, 36, 36)];		
	gob = [[UIImage imageNamed:@"Marron-poing3.png"] retain];		
	[icon2V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon2V];
	
	ic2TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 120, 330, 100 )];
	ic2TV.backgroundColor = [UIColor clearColor];
	ic2TV.font = [UIFont fontWithName:@"Arial" size:12];
	ic2TV.scrollEnabled = NO;
	ic2TV.editable = NO;
	ic2TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	ic2TV.text = NSLocalizedString(@"Help6.2Text", @"This icon is the 'use-action' icon. It allows you to cast spells with the magician, to punch something with the warrior or to use an object with the technician.");
	[ic2TV setUserInteractionEnabled:NO];					
	[self.view addSubview:ic2TV];	
	
	icon3V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 185, 36, 36)];		
	gob = [[UIImage imageNamed:@"Marron-Main4.png"] retain];		
	[icon3V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon3V];
	
	ic3TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 170, 330, 100 )];
	ic3TV.backgroundColor = [UIColor clearColor];
	ic3TV.font = [UIFont fontWithName:@"Arial" size:12];
	ic3TV.scrollEnabled = NO;
	ic3TV.editable = NO;
	ic3TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	ic3TV.text = NSLocalizedString(@"Help6.3Text", @"This icon is only available with the technician. It allows you to pick or drop an object with this gobliiin only. Remember, he can only possess one object at a time.");
	[ic3TV setUserInteractionEnabled:NO];						
	[self.view addSubview:ic3TV];
	
	icon4V = [[UIImageView alloc] initWithFrame:CGRectMake(75, 235, 36, 36)];		
	gob = [[UIImage imageNamed:@"Marron-Croix3.png"] retain];		
	[icon4V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon4V];
	
	ic4TV = [[UITextView alloc ] initWithFrame:CGRectMake( 130, 225, 330, 100 )];
	ic4TV.backgroundColor = [UIColor clearColor];
	ic4TV.font = [UIFont fontWithName:@"Arial" size:12];
	ic4TV.scrollEnabled = NO;
	ic4TV.editable = NO;
	ic4TV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	ic4TV.text = NSLocalizedString(@"Help6.4Text", @"Finally, this icon is the cancel one. If you make a mistake, just touch it and you're free to choose another action!");
	[ic4TV setUserInteractionEnabled:NO];	
	[self.view addSubview:ic4TV];
}

-(void) removePageSix
{
	if( icon1V != nil && icon1V.superview != nil )
	{
		[icon1V removeFromSuperview];
		[icon1V release];
		icon1V = nil;
	}
	if( icon2V != nil && icon2V.superview != nil )
	{
		[icon2V removeFromSuperview];
		[icon2V release];		
		icon2V = nil;
	}
	if( icon3V != nil && icon3V.superview != nil )
	{
		[icon3V removeFromSuperview];
		[icon3V release];		
		icon3V = nil;
	}
	if( icon4V != nil && icon4V.superview != nil )
	{
		[icon4V removeFromSuperview];
		[icon4V release];		
		icon4V = nil;
	}
	
	if( ic1TV != nil && ic1TV.superview != nil )
	{
		[ic1TV removeFromSuperview];
		[ic1TV release];		
		ic1TV = nil;
	}
	if( ic2TV != nil && ic2TV.superview != nil )
	{
		[ic2TV removeFromSuperview];
		[ic2TV release];			
		ic2TV = nil;
	}
	if( ic3TV != nil && ic3TV.superview != nil )
	{
		[ic3TV removeFromSuperview];
		[ic3TV release];			
		ic3TV = nil;
	}
	if( ic4TV != nil && ic4TV.superview != nil )
	{
		[ic4TV removeFromSuperview];
		[ic4TV release];			
		ic4TV = nil;
	}
}

-(void) loadPageThreeCursor
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	touchV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:NSLocalizedString(@"HelpImgCursor", @"help-cursor.png") ] retain];		
	[touchV setImage:gob];		
	[gob release];		
	[self.view addSubview:touchV];
	[self.view insertSubview:m_menu aboveSubview:touchV];
	[self.view insertSubview:m_nextState aboveSubview:touchV];
	[self.view insertSubview:m_prevState aboveSubview:touchV];
	
	touchTV = [[UITextView alloc ] initWithFrame:CGRectMake( 315, 70, 135, 170 )];
	touchTV.backgroundColor = [UIColor clearColor];
	touchTV.font = [UIFont fontWithName:@"Arial" size:12];
	touchTV.scrollEnabled = NO;
	touchTV.editable = NO;
	touchTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	touchTV.text = NSLocalizedString(@"Help3c.1Text", @"In this control mode, just drag the cursor wherever you want and release your finger to choose an action.\n\nThe hotspots around the cursor will be displayed (   ).");
	[touchTV setUserInteractionEnabled:NO];		
	[self.view addSubview:touchTV];
	[self.view insertSubview:touchTV aboveSubview:touchV];
	
	if( _GobLanguage == 0 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake( 380.5, 216, 10, 10 )];
	else if( _GobLanguage == 1 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake( 394, 230, 10, 10 )];
	gob = [[UIImage imageNamed:@"point d'exclamation bleu.png"] retain];		
	[markV setImage:gob];		
	[gob release];		
	[self.view addSubview:markV];
}

-(void) removePageThreeCursor
{
	if( touchV != nil && touchV.superview != nil )
	{
		[touchV removeFromSuperview];
		[touchV release];	
		touchV = nil;
	}
	
	if( touchTV != nil && touchTV.superview != nil )
	{
		[touchTV removeFromSuperview];
		[touchTV release];			
		touchTV = nil;
	}
	
	if( markV != nil && markV.superview != nil )
	{
		[markV removeFromSuperview];
		[markV release];			
		markV = nil;
	}
}

-(void) loadPageThree
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	touchV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:NSLocalizedString(@"HelpImgHotspot", @"Help-touch hotspot.png") ] retain];		
	[touchV setImage:gob];		
	[gob release];		
	[self.view addSubview:touchV];
	[self.view insertSubview:m_menu aboveSubview:touchV];
	[self.view insertSubview:m_nextState aboveSubview:touchV];
	[self.view insertSubview:m_prevState aboveSubview:touchV];
	
	touchTV = [[UITextView alloc ] initWithFrame:CGRectMake( 315, 70, 135, 170 )];
	touchTV.backgroundColor = [UIColor clearColor];
	touchTV.font = [UIFont fontWithName:@"Arial" size:12];
	touchTV.scrollEnabled = NO;
	touchTV.editable = NO;
	touchTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	touchTV.text = NSLocalizedString(@"Help3.1Text", @"In touch mode, when you move your finger on the screen, the position of an hotspot will be displayed by   .\n\nYou now know the objects you can interact with.");
	[touchTV setUserInteractionEnabled:NO];		
	[self.view addSubview:touchTV];
	[self.view insertSubview:touchTV aboveSubview:touchV];
	
	if( _GobLanguage == 0 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake( 427, 141, 10, 10 )];	
	else if( _GobLanguage == 1 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake( 351.5, 140.5, 10, 10 )];	
	gob = [[UIImage imageNamed:@"point d'exclamation bleu.png"] retain];		
	[markV setImage:gob];		
	[gob release];		
	[self.view addSubview:markV];
}

-(void) removePageThree
{
	if( touchV != nil && touchV.superview != nil )
	{
		[touchV removeFromSuperview];
		[touchV release];	
		touchV = nil;
	}
	
	if( touchTV != nil && touchTV.superview != nil )
	{
		[touchTV removeFromSuperview];
		[touchTV release];			
		touchTV = nil;
	}
}

-(void) loadPageFour
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	touchV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:NSLocalizedString(@"HelpImgTouch", @"Help-touch fond2.png") ] retain];		
	[touchV setImage:gob];		
	[gob release];		
	[self.view addSubview:touchV];
	[self.view insertSubview:m_menu aboveSubview:touchV];
	[self.view insertSubview:m_nextState aboveSubview:touchV];
	[self.view insertSubview:m_prevState aboveSubview:touchV];
	
	touchTV = [[UITextView alloc ] initWithFrame:CGRectMake( 315, 70, 135, 170 )];
	touchTV.backgroundColor = [UIColor clearColor];
	touchTV.font = [UIFont fontWithName:@"Arial" size:12];
	touchTV.scrollEnabled = NO;
	touchTV.editable = NO;
	touchTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	touchTV.text = NSLocalizedString(@"Help4.1Text", @"When you move your finger on an hotspot, the possible actions are displayed.\n\nRelease your finger and choose one!");
	[touchTV setUserInteractionEnabled:NO];		
	[self.view addSubview:touchTV];
	
	[self.view insertSubview:touchTV aboveSubview:touchV];
	
	touchL = [[UILabel alloc ] initWithFrame:CGRectMake( 77.5, 256, 200, 30 )];
	touchL.text = NSLocalizedString(@"HelpObjText", @"Object name");
	touchL.textColor = [UIColor blackColor];
	touchL.backgroundColor = [UIColor clearColor];
	touchL.font = [UIFont fontWithName:@"Arial" size:10];
	[touchL setUserInteractionEnabled:NO];		
	
	[self.view insertSubview:touchL aboveSubview:touchV];
}

-(void) removePageFour
{
	if( touchV != nil && touchV.superview != nil )
	{
		[touchV removeFromSuperview];
		[touchV release];		
		touchV = nil;
	}
	
	if( touchL != nil && touchL.superview != nil )
	{
		[touchL removeFromSuperview];
		[touchL release];		
		touchL = nil;
	}
	
	if( touchTV != nil && touchTV.superview != nil )
	{
		[touchTV removeFromSuperview];
		[touchTV release];			
		touchTV = nil;
	}
}

-(void) loadPageFive
{
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	touchV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:NSLocalizedString(@"HelpImgFree", @"Help-touch free.png") ] retain];		
	[touchV setImage:gob];		
	[gob release];		
	[self.view addSubview:touchV];
	[self.view insertSubview:m_menu aboveSubview:touchV];
	[self.view insertSubview:m_nextState aboveSubview:touchV];
	[self.view insertSubview:m_prevState aboveSubview:touchV];
	
	touchTV = [[UITextView alloc ] initWithFrame:CGRectMake( 315, 70, 135, 170 )];
	touchTV.backgroundColor = [UIColor clearColor];
	touchTV.font = [UIFont fontWithName:@"Arial" size:12];
	touchTV.scrollEnabled = NO;
	touchTV.editable = NO;
	touchTV.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	touchTV.text = NSLocalizedString(@"Help5.1Text", @"You can also use actions on an empty area.\n\nFor that, just keep your finger on the screen during 1 second and then release it.");
	[touchTV setUserInteractionEnabled:NO];		
	[self.view addSubview:touchTV];
	
	[self.view insertSubview:touchTV aboveSubview:touchV];
	
	touchL = [[UILabel alloc ] initWithFrame:CGRectMake( 77.5, 256, 200, 30 )];
	touchL.text = NSLocalizedString(@"HelpObjText", @"Object name");
	touchL.textColor = [UIColor blackColor];
	touchL.backgroundColor = [UIColor clearColor];
	touchL.font = [UIFont fontWithName:@"Arial" size:10];
	[touchL setUserInteractionEnabled:NO];	
	
	[self.view insertSubview:touchL aboveSubview:touchV];
}

-(void) removePageFive
{
	if( touchV != nil && touchV.superview != nil )
	{
		[touchV removeFromSuperview];
		[touchV release];			
		touchV = nil;
	}
	
	if( touchL != nil && touchL.superview != nil )
	{
		[touchL removeFromSuperview];
		[touchL release];			
		touchL = nil;
	}
	
	if( touchTV != nil && touchTV.superview != nil )
	{
		[touchTV removeFromSuperview];
		[touchTV release];			
		touchTV = nil;
	}
}

-(void) loadBackground:(NSString*)background
{
	fondV = [[UIImageView alloc] initWithFrame:CGRectMake(130, 35, 220, 30)];		
	fond = [[UIImage imageNamed:background] retain];		
	[fondV setImage:fond];		
	[fond release];		
	[self.view addSubview:fondV];
	
	[self.view insertSubview:m_menu aboveSubview:fondV];
	[self.view insertSubview:m_nextState aboveSubview:fondV];
	[self.view insertSubview:m_prevState aboveSubview:fondV];
}

-(void) removeBackground
{
	if( fondV != nil && fondV.superview != nil )
	{
		[fondV removeFromSuperview];
		[fondV release];		
		fondV = nil;
	}
}

//anim finished
- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	[self.view removeFromSuperview];
	if( !bWarning )
		[[NSNotificationCenter defaultCenter] postNotificationName:@"animationN" object:nil];		
	else
		bWarning = false;
	
	//clear
	[self removeBackground];
	[self removePageOne];
	[self removePageTwo];
	[self removePageThree];
	[self removePageThreeCursor];
	[self removePageFour];
	[self removePageFive];
	[self removePageSix];
	etatNext = 0;
	m_prevState.hidden = YES;
	m_nextState.hidden = NO;
	[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
	[self loadPageZero];
}

-(IBAction) menuClicked:(id)sender
{
	//NSLog(@"helpViewController menuClicked");	

	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
}

-(IBAction) nextClicked:(id)sender
{
	//NSLog(@"helpViewController nextClicked");		
	etatNext++;
	
	//clear
	[self removeBackground];
	[self removePageOne];
	[self removePageTwo];
	[self removePageThreeCursor];
	[self removePageThree];
	[self removePageFour];
	[self removePageFive];
	[self removePageSix];
	
	switch( etatNext )
	{
		case 0:
			m_prevState.hidden = YES;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
			[self loadPageZero];
			break;
		case 1:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgGobliiins", @"help-gobliiins.png") ];
			[self loadPageOne];
			break;
		case 2:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgInventory", @"help-inventory.png") ];
			[self loadPageTwo];
			break;
		case 3:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThreeCursor];
			break;
		case 4:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThree];
			break;
		case 5:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageFour];
			break;
		case 6:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageFive];
			break;
		case 7:	
			m_prevState.hidden = NO;
			m_nextState.hidden = YES;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgActions", @"help-actions.png") ];
			[self loadPageSix];
			break;
	}

	if( etatNext > 0 )
		m_prevState.hidden = NO;
	if( etatNext == 7 )
		m_nextState.hidden = YES;
}

-(IBAction) prevClicked:(id)sender
{
	//NSLog(@"helpViewController prevClicked");			
	etatNext--;

	//clear
	[self removeBackground];
	[self removePageOne];
	[self removePageTwo];
	[self removePageThreeCursor];
	[self removePageThree];
	[self removePageFour];
	[self removePageFive];
	[self removePageSix];
	
	switch( etatNext )
	{
		case 0:
			m_prevState.hidden = YES;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
			[self loadPageZero];
			break;
		case 1:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgGobliiins", @"help-gobliiins.png") ];
			[self loadPageOne];
			break;
		case 2:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgInventory", @"help-inventory.png") ];
			[self loadPageTwo];
			break;
		case 3:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThreeCursor];
			break;
		case 4:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThree];
			break;
		case 5:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageFour];
			break;
		case 6:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageFive];
			break;
		case 7:	
			m_prevState.hidden = NO;
			m_nextState.hidden = YES;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgActions", @"help-actions.png") ];
			[self loadPageSix];
			break;
	}
	
	if( etatNext == 0 )
	{
		m_prevState.hidden = YES;
		m_nextState.hidden = NO;
	}
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	//NSLog(@"helpViewController webViewDidFinishLoad");
	if( etatNext == 0 )
	{
		[activityIndicatorGWV stopAnimating];
		activityIndicatorGWV.hidden = YES;
	}
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	//NSLog(@"helpViewController webViewDidStartLoad");
	if( etatNext == 0 )
	{
		activityIndicatorGWV.hidden = NO;
		[activityIndicatorGWV startAnimating];
	}
}

@end
