//
//  hintViewController.mm
//  scummvm
//
//  Created by DotEmu on 12/04/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#include <semaphore.h>
#import "iPhoneViewController.h"
#import "hintViewController.h"
#import "iphone_common.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern int idLvLCourant;
extern bool bSleepMode;
//GAME
extern int _GobLanguage;
extern bool bHintMenuActive;
extern UIButton* externMenuButton;
extern UIButton* externHintButton;
//SOUND
extern bool bSoundMusicActive;
extern int idSoundSFX;
//DEFINES
extern iPhoneViewController* g_iVC;
extern AVAudioPlayer* audioPlayer;
extern bool bSem;
extern sem_t* sem;
//---END
////////////////

@implementation hintViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"hintViewController viewDidLoad");
    [super viewDidLoad];

	hintView.backgroundColor = [UIColor clearColor];
	hintView.opaque = NO;
	hintView.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath = [[NSBundle mainBundle] resourcePath];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error = nil;
	NSString *intString = nil;
	if( _GobLanguage == 0 )
		 intString = [NSString stringWithFormat:@"%d", idLvLCourant];
	else if( _GobLanguage == 1 )
		intString = [NSString stringWithFormat:@"%d_fr", idLvLCourant];
	NSString *fullPath = [[NSBundle mainBundle] pathForResource:intString ofType:@"html"];
	NSString *helpHtml = [NSString stringWithContentsOfFile:fullPath encoding:NSUTF8StringEncoding error:&error];
	
	[hintView loadHTMLString:helpHtml baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath]]];
	//[hintView setUserInteractionEnabled:NO];
	hintView.delegate = self;
	
	hint1B.exclusiveTouch = YES;
	hint2B.exclusiveTouch = YES;
	hint3B.exclusiveTouch = YES;
	
	switch( idLvLCourant )
	{
		case 3: 
			hint1B.hidden = NO;
			hint2B.hidden = YES;
			hint3B.hidden = YES;
			break;
		case 14:
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = YES;
			break;
		case 16:
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = YES;
			break;
		case 18:
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = YES;
			break;
		case 21:
			hint1B.hidden = NO;
			hint2B.hidden = YES;
			hint3B.hidden = YES;
			break;
		default:
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
	}
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];
	hintPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	hintPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	hintPlayer.numberOfLoops = 0;
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"hintViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
	
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"hintViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( hintView != nil )
	{
		[hintView release];
		hintView = nil;
	}
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
}

- (void)dealloc 
{
	//NSLog(@"hintViewController viewDidUnload");	
    [super dealloc];	
	if( hintView != nil )
	{
		[hintView release];
		hintView = nil;
	}
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
	[hint1B release];	
	[hint2B release];
	[hint3B release];	
}

//back click to iPhoneView
-(IBAction) backClickedDown:(id)sender
{
	//NSLog(@"hintViewController backClickedDown");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bSoundMusicActive )
		[audioPlayer play];
	
	bSleepMode = false;
	if( bSem )
	{
		sem_post( sem );		
		bSem = false;
	}
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( 0, 320, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
}

- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	bHintMenuActive = false;
	externMenuButton.enabled = YES;
	externHintButton.enabled = YES;	
}

-(IBAction) hint1ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint1ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];	
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='none';"]];	
}

-(IBAction) hint2ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint2ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='none';"]];	
}

-(IBAction) hint3ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint3ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='none';"]];	
}

//DELEGATES

//UIWebView
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
	//NSLog(@"hintViewController didFailLoadWithError");
	[activityIndicator stopAnimating];
	NSMutableString *html = [[NSMutableString alloc] initWithString: @"<html><head></head><style type=\"text/css\">body{ background-color: transparent; color: #ffffff;</style><body>"];
	[html appendString: @"Error"];
	[html appendString: @"</body></html>"];
	[hintView loadHTMLString:html baseURL:nil];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	//NSLog(@"hintViewController webViewDidFinishLoad");
	[activityIndicator stopAnimating];
	activityIndicator.hidden = YES;
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	//NSLog(@"hintViewController webViewDidStartLoad");
	activityIndicator.hidden = NO;
	[activityIndicator startAnimating];
}

@end
